
__forceinline__ __device__ void
get_Ticket ( int * Ticket, const int is_master, const int block_id )
{
   if ( is_master ) {
      while ( 1 ) {
         int T = gridDim.x;
         if ( atomicCAS( Ticket, block_id, T ) == block_id ) break;
      }
   }
   __syncthreads ( );
}


__forceinline__ __device__ void
release_Ticket ( int * Ticket, const int is_master, const int next_block_id )
{
   __syncthreads ( );
   if ( is_master ) {
      int T = next_block_id;
      atomicExch ( Ticket, T );
   }
}

__forceinline__ __device__ void
skip_Ticket ( int * Ticket, const int is_master, const int block_id, const int next_block_id )
{
   if ( is_master ) {
      while ( 1 ) {
         int T = next_block_id;
         if ( atomicCAS( Ticket, block_id, T ) == block_id ) break;
      }
   }
   __syncthreads ( );
}


