#!/bin/sh

echo_Message()
{
	echo '<--/****************************************'
	echo 'Automatic Performance Tuning for DSYMV-U'
	date
	echo -n 'Host on '; echo `hostname`
	echo 'Device is '$DEVICE
	if [ x${1} = xbegin ]; then
		echo 'Start.'
	fi
	if [ x${1} = xend ]; then
		echo 'Successfully completed.'
	fi
	if [ x${1} = xterminate ]; then
		echo 'Terminated unfortunately.'
	fi
	echo '****************************************/-->'
}


export LANG=C
LOG=log-dsymvu-AT1X.`date +%Y.%m.%d.%T`
WORK_DIR=dsymvu-current

if [ x${CUDA_PATH} != x ]; then
        export LD_LIBRARY_PATH=$CUDA_PATH/lib64:$LD_LIBRARY_PATH
fi

../src/get_dev_info $ASPEN_GPU_ID > DEV_INFO

DEVICE=`awk '/DEVICE=/{ print $2 }' DEV_INFO`
MP=`awk '/MP=/{ print $2 }' DEV_INFO`
CG=`awk '/CG=/{ print $2 }' DEV_INFO`
MAXDIM=`awk '/MAXDIM=/{ print $2 }' DEV_INFO`

echo_Message begin

/bin/sh ./touch_header.sh

mkdir $LOG
if [ -f $WORK_DIR ]; then
	\rm -rf $WORK_DIR
fi
if [ -h $WORK_DIR ]; then
	\rm $WORK_DIR
fi
if [ -d $WORK_DIR ]; then
	\rm -rf $WORK_DIR
fi
ln -s $LOG $WORK_DIR

cd $WORK_DIR
cd ../../src; make get_dev_info; cd ../tuning/$WORK_DIR
ln -s ../../src/get_dev_info .

/bin/sh ../d.sh > OK-pat-symv

/bin/sh ../dsymvu_a.sh | tee $LOG
/bin/sh ../dsymvu_b.sh $LOG
/bin/sh ../dsymvu_b2.sh $LOG-X
/bin/sh ../dsymvu_c.sh
/bin/sh ../d_filter.sh dsymv-upper-auto3.h dsymv-upper-auto2.h

echo '#if 0'             > dsymv-upper-auto_.h
echo_Message            >> dsymv-upper-auto_.h
cat ../DEV_INFO         >> dsymv-upper-auto_.h
cat ../CURRENT_GPU      >> dsymv-upper-auto_.h
echo '#endif'           >> dsymv-upper-auto_.h
cat dsymv-upper-auto.h  >> dsymv-upper-auto_.h
mv dsymv-upper-auto_.h dsymv-upper-auto.h
cp dsymv-upper-auto.h ..

echo '#if 0'             > dsymv-upper-auto_.h
echo_Message            >> dsymv-upper-auto_.h
cat ../DEV_INFO         >> dsymv-upper-auto_.h
cat ../CURRENT_GPU      >> dsymv-upper-auto_.h
echo '#endif'           >> dsymv-upper-auto_.h
cat dsymv-upper-auto2.h >> dsymv-upper-auto_.h
mv dsymv-upper-auto_.h dsymv-upper-auto2.h
cp dsymv-upper-auto2.h ..

cat dsymv-upper-auto.h
cat dsymv-upper-auto2.h

cd ../../src

\rm dsymv_upper-*.cu_o
make -j4

cd ../bench

\rm test.o test2.o
make test-d

cd ../tuning

touch .done-dsymvu

echo_Message end

exit 0

