#!/bin/sh

echo_Message()
{
	echo '<--/****************************************'
	echo 'Automatic Performance Tuning for SSYMV-L'
	date
	echo -n 'Host on '; echo `hostname`
	echo 'Device is '$DEVICE
	if [ x${1} = xbegin ]; then
		echo 'Start.'
	fi
	if [ x${1} = xend ]; then
		echo 'Successfully completed.'
	fi
	if [ x${1} = xterminate ]; then
		echo 'Terminated unfortunately.'
	fi
	echo '****************************************/-->'
}


export LANG=C
LOG=log-ssymvl-AT1X.`date +%Y.%m.%d.%T`
WORK_DIR=ssymvl-current

if [ x${CUDA_PATH} != x ]; then
        export LD_LIBRARY_PATH=$CUDA_PATH/lib64:$LD_LIBRARY_PATH
fi

../src/get_dev_info $ASPEN_GPU_ID > DEV_INFO

DEVICE=`awk '/DEVICE=/{ print $2 }' DEV_INFO`
MP=`awk '/MP=/{ print $2 }' DEV_INFO`
CG=`awk '/CG=/{ print $2 }' DEV_INFO`
MAXDIM=`awk '/MAXDIM=/{ print $2 }' DEV_INFO`

echo_Message begin

/bin/sh ./touch_header.sh

mkdir $LOG
if [ -f $WORK_DIR ]; then
	\rm -rf $WORK_DIR
fi
if [ -h $WORK_DIR ]; then
	\rm $WORK_DIR
fi
if [ -d $WORK_DIR ]; then
	\rm -rf $WORK_DIR
fi
ln -s $LOG $WORK_DIR

cd $WORK_DIR
cd ../../src; make get_dev_info; cd ../tuning/$WORK_DIR
ln -s ../../src/get_dev_info .

/bin/sh ../d.sh > OK-pat-symv

/bin/sh ../ssymvl_a.sh | tee $LOG
/bin/sh ../ssymvl_b.sh $LOG
/bin/sh ../ssymvl_b2.sh $LOG-X
/bin/sh ../ssymvl_c.sh
/bin/sh ../d_filter.sh ssymv-lower-auto3.h ssymv-lower-auto2.h

echo '#if 0'             > ssymv-lower-auto_.h
echo_Message            >> ssymv-lower-auto_.h
cat ../DEV_INFO         >> ssymv-lower-auto_.h
cat ../CURRENT_GPU      >> ssymv-lower-auto_.h
echo '#endif'           >> ssymv-lower-auto_.h
cat ssymv-lower-auto.h  >> ssymv-lower-auto_.h
mv ssymv-lower-auto_.h ssymv-lower-auto.h
cp ssymv-lower-auto.h ..

echo '#if 0'             > ssymv-lower-auto_.h
echo_Message            >> ssymv-lower-auto_.h
cat ../DEV_INFO         >> ssymv-lower-auto_.h
cat ../CURRENT_GPU      >> ssymv-lower-auto_.h
echo '#endif'           >> ssymv-lower-auto_.h
cat ssymv-lower-auto2.h >> ssymv-lower-auto_.h
mv ssymv-lower-auto_.h ssymv-lower-auto2.h
cp ssymv-lower-auto2.h ..

cat ssymv-lower-auto.h
cat ssymv-lower-auto2.h

cd ../../src

\rm ssymv_lower-*.cu_o
make -j4

cd ../bench

\rm test-f.o test2-f.o
make test-s

cd ../tuning

touch .done-ssymvl

echo_Message end

exit 0

