#if 0
<--/****************************************
Automatic Performance Tuning for DGEMV -T
2015年  1月 12日 月曜日 14:25:34 JST
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-580
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="gauss.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-580";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(16)
#endif
#if !defined(scalar_t)
#define scalar_t	double
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_DGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_4	1
#define	KERNEL_5	1
#define	KERNEL_18	1
#define	KERNEL_8	1
#define	KERNEL_9	1
#define	KERNEL_10	1
#define	KERNEL_11	1
#define	KERNEL_12	1
#define	KERNEL_0	1
#define	KERNEL_14	1
#define	KERNEL_1	1
#define	KERNEL_15	1
#define	KERNEL_2	1
#define	KERNEL_3	1

if ( n >= 1 && n < 250 ) {
	BLK = 9;
} else
if ( n >= 250 && n < 448 ) {
	BLK = 8;
} else
if ( n >= 448 && n < 512 ) {
	BLK = 15;
} else
if ( n >= 512 && n < 576 ) {
	BLK = 11;
} else
if ( n >= 576 && n < 598 ) {
	BLK = 4;
} else
if ( n >= 598 && n < 640 ) {
	BLK = 10;
} else
if ( n >= 640 && n < 768 ) {
	BLK = 5;
} else
if ( n >= 768 && n < 776 ) {
	BLK = 4;
} else
if ( n >= 776 && n < 960 ) {
	BLK = 14;
} else
if ( n >= 960 && n < 1280 ) {
	BLK = 1;
} else
if ( n >= 1280 && n < 1393 ) {
	BLK = 0;
} else
if ( n >= 1393 && n < 1428 ) {
	BLK = 14;
} else
if ( n >= 1428 && n < 1536 ) {
	BLK = 1;
} else
if ( n >= 1536 && n < 1757 ) {
	BLK = 0;
} else
if ( n >= 1757 && n < 1792 ) {
	BLK = 1;
} else
if ( n >= 1792 && n < 3018 ) {
	BLK = 0;
} else
if ( n >= 3018 && n < 3072 ) {
	BLK = 14;
} else
if ( n >= 3072 && n < 3469 ) {
	BLK = 0;
} else
if ( n >= 3469 && n < 3584 ) {
	BLK = 14;
} else
if ( n >= 3584 && n < 3909 ) {
	BLK = 0;
} else
if ( n >= 3909 && n < 4060 ) {
	BLK = 14;
} else
if ( n >= 4060 && n < 4096 ) {
	BLK = 18;
} else
if ( n >= 4096 && n < 4308 ) {
	BLK = 0;
} else
if ( n >= 4308 && n < 4430 ) {
	BLK = 14;
} else
if ( n >= 4430 && n < 4594 ) {
	BLK = 18;
} else
if ( n >= 4594 && n < 4608 ) {
	BLK = 5;
} else
if ( n >= 4608 && n < 4643 ) {
	BLK = 0;
} else
if ( n >= 4643 && n < 4992 ) {
	BLK = 2;
} else
if ( n >= 4992 && n < 5101 ) {
	BLK = 18;
} else
if ( n >= 5101 && n < 5120 ) {
	BLK = 15;
} else
if ( n >= 5120 && n < 5330 ) {
	BLK = 2;
} else
if ( n >= 5330 && n < 5376 ) {
	BLK = 5;
} else
if ( n >= 5376 && n < 5602 ) {
	BLK = 18;
} else
if ( n >= 5602 && n < 5632 ) {
	BLK = 15;
} else
if ( n >= 5632 && n < 6061 ) {
	BLK = 2;
} else
if ( n >= 6061 && n < 6102 ) {
	BLK = 18;
} else
if ( n >= 6102 && n < 6144 ) {
	BLK = 15;
} else
if ( n >= 6144 && n < 6160 ) {
	BLK = 2;
} else
if ( n >= 6160 && n < 6240 ) {
	BLK = 3;
} else
if ( n >= 6240 && n < 6528 ) {
	BLK = 2;
} else
if ( n >= 6528 && n < 6582 ) {
	BLK = 18;
} else
if ( n >= 6582 && n < 6609 ) {
	BLK = 12;
} else
if ( n >= 6609 && n < 6656 ) {
	BLK = 15;
} else
if ( n >= 6656 && n < 6720 ) {
	BLK = 3;
} else
if ( n >= 6720 && n < 6878 ) {
	BLK = 2;
} else
if ( n >= 6878 && n < 6912 ) {
	BLK = 5;
} else
if ( n >= 6912 && n < 7059 ) {
	BLK = 2;
} else
if ( n >= 7059 && n < 7128 ) {
	BLK = 12;
} else
if ( n >= 7128 && n < 7168 ) {
	BLK = 15;
} else
if ( n >= 7168 && n < 7200 ) {
	BLK = 3;
} else
if ( n >= 7200 && n < 7591 ) {
	BLK = 2;
} else
if ( n >= 7591 && n < 7675 ) {
	BLK = 3;
} else
if ( n >= 7675 && n < 7680 ) {
	BLK = 15;
} else
if ( n >= 7680 && n < 8064 ) {
	BLK = 2;
} else
if ( n >= 8064 && n < 8160 ) {
	BLK = 3;
} else
if ( n >= 8160 && n < 8166 ) {
	BLK = 12;
} else
if ( n >= 8166 && n < 8192 ) {
	BLK = 15;
} else
if ( n >= 8192 && n < 8422 ) {
	BLK = 2;
} else
if ( n >= 8422 && n < 8448 ) {
	BLK = 5;
} else
if ( n >= 8448 && n < 8640 ) {
	BLK = 3;
} else
if ( n >= 8640 && n < 8684 ) {
	BLK = 12;
} else
if ( n >= 8684 && n < 8704 ) {
	BLK = 15;
} else
if ( n >= 8704 && n < 8898 ) {
	BLK = 2;
} else
if ( n >= 8898 && n < 9120 ) {
	BLK = 3;
} else
if ( n >= 9120 && n < 9203 ) {
	BLK = 12;
} else
if ( n >= 9203 && n < 9216 ) {
	BLK = 15;
} else
if ( n >= 9216 && n < 9375 ) {
	BLK = 2;
} else
if ( n >= 9375 && n < 9600 ) {
	BLK = 3;
} else
if ( n >= 9600 && n < 9721 ) {
	BLK = 12;
} else
if ( n >= 9721 && n < 9728 ) {
	BLK = 15;
} else
if ( n >= 9728 && n < 9851 ) {
	BLK = 2;
} else
if ( n >= 9851 && n < 10080 ) {
	BLK = 3;
} else
if ( n >= 10080 && n < 10239 ) {
	BLK = 12;
} else
if ( n >= 10239 && n < 10240 ) {
	BLK = 15;
} else
if ( n >= 10240 && n < 10326 ) {
	BLK = 2;
} else
if ( n >= 10326 && n < 10560 ) {
	BLK = 3;
} else
if ( n >= 10560 && n < 10617 ) {
	BLK = 2;
} else
if ( n >= 10617 && n < 10752 ) {
	BLK = 12;
} else
if ( n >= 10752 && n < 11040 ) {
	BLK = 3;
} else
if ( n >= 11040 && n < 11136 ) {
	BLK = 2;
} else
if ( n >= 11136 && n < 11264 ) {
	BLK = 12;
} else
if ( n >= 11264 && n < 11520 ) {
	BLK = 3;
} else
if ( n >= 11520 && n < 11563 ) {
	BLK = 2;
} else
if ( n >= 11563 && n < 11776 ) {
	BLK = 12;
} else
if ( n >= 11776 && n < 12000 ) {
	BLK = 3;
} else
if ( n >= 12000 && n < 12108 ) {
	BLK = 2;
} else
if ( n >= 12108 && n < 12480 ) {
	BLK = 3;
} else
if ( n >= 12480 && n < 12584 ) {
	BLK = 2;
} else
if ( n >= 12584 && n < 12768 ) {
	BLK = 3;
} else
if ( n >= 12768 && n < 100000000 ) {
	BLK = 3;
}

#if 1
	int ii=BLK;
#define DGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
		GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
		( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		DGEMVT_KERNEL_ ( 192 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		DGEMVT_KERNEL_ ( 160 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		DGEMVT_KERNEL_ ( 128 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		DGEMVT_KERNEL_ ( 64 , 3 , 2, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		DGEMVT_KERNEL_ ( 48 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		DGEMVT_KERNEL_ ( 32 , 3 , 2, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		DGEMVT_KERNEL_ ( 48 , 4 , 4, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		DGEMVT_KERNEL_ ( 64 , 4 , 2, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		DGEMVT_KERNEL_ ( 64 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		DGEMVT_KERNEL_ ( 32 , 3 , 4, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		DGEMVT_KERNEL_ ( 48 , 4 , 2, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		DGEMVT_KERNEL_ ( 48 , 3 , 2, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		DGEMVT_KERNEL_ ( 64 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		DGEMVT_KERNEL_ ( 160 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		DGEMVT_KERNEL_ ( 96 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		DGEMVT_KERNEL_ ( 48 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		DGEMVT_KERNEL_ ( 32 , 4 , 2, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		DGEMVT_KERNEL_ ( 64 , 3 , 4, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		DGEMVT_KERNEL_ ( 96 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		DGEMVT_KERNEL_ ( 160 , 1 , 6, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

