#if 0
<--/****************************************
Automatic Performance Tuning for DGEMV -T
2015年  1月 22日 木曜日 16:04:35 JST
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-980
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="gauss.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-980";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(16)
#endif
#if !defined(scalar_t)
#define scalar_t	double
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_DGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_4	1
#define	KERNEL_5	1
#define	KERNEL_7	1
#define	KERNEL_10	1
#define	KERNEL_12	1
#define	KERNEL_0	1
#define	KERNEL_13	1
#define	KERNEL_14	1
#define	KERNEL_1	1
#define	KERNEL_2	1
#define	KERNEL_3	1
#define	KERNEL_16	1

if ( n >= 1 && n < 457 ) {
	BLK = 7;
} else
if ( n >= 457 && n < 757 ) {
	BLK = 5;
} else
if ( n >= 757 && n < 1386 ) {
	BLK = 10;
} else
if ( n >= 1386 && n < 1819 ) {
	BLK = 4;
} else
if ( n >= 1819 && n < 1920 ) {
	BLK = 7;
} else
if ( n >= 1920 && n < 2016 ) {
	BLK = 5;
} else
if ( n >= 2016 && n < 2048 ) {
	BLK = 10;
} else
if ( n >= 2048 && n < 2240 ) {
	BLK = 14;
} else
if ( n >= 2240 && n < 2304 ) {
	BLK = 2;
} else
if ( n >= 2304 && n < 2332 ) {
	BLK = 3;
} else
if ( n >= 2332 && n < 2505 ) {
	BLK = 14;
} else
if ( n >= 2505 && n < 2592 ) {
	BLK = 2;
} else
if ( n >= 2592 && n < 2658 ) {
	BLK = 1;
} else
if ( n >= 2658 && n < 2688 ) {
	BLK = 16;
} else
if ( n >= 2688 && n < 2732 ) {
	BLK = 3;
} else
if ( n >= 2732 && n < 2734 ) {
	BLK = 1;
} else
if ( n >= 2734 && n < 2880 ) {
	BLK = 2;
} else
if ( n >= 2880 && n < 2923 ) {
	BLK = 3;
} else
if ( n >= 2923 && n < 3072 ) {
	BLK = 1;
} else
if ( n >= 3072 && n < 3102 ) {
	BLK = 3;
} else
if ( n >= 3102 && n < 3168 ) {
	BLK = 2;
} else
if ( n >= 3168 && n < 3264 ) {
	BLK = 1;
} else
if ( n >= 3264 && n < 3306 ) {
	BLK = 3;
} else
if ( n >= 3306 && n < 3348 ) {
	BLK = 1;
} else
if ( n >= 3348 && n < 3442 ) {
	BLK = 12;
} else
if ( n >= 3442 && n < 3456 ) {
	BLK = 2;
} else
if ( n >= 3456 && n < 3475 ) {
	BLK = 3;
} else
if ( n >= 3475 && n < 3808 ) {
	BLK = 12;
} else
if ( n >= 3808 && n < 3840 ) {
	BLK = 1;
} else
if ( n >= 3840 && n < 3884 ) {
	BLK = 3;
} else
if ( n >= 3884 && n < 4032 ) {
	BLK = 1;
} else
if ( n >= 4032 && n < 4078 ) {
	BLK = 3;
} else
if ( n >= 4078 && n < 4224 ) {
	BLK = 1;
} else
if ( n >= 4224 && n < 4271 ) {
	BLK = 3;
} else
if ( n >= 4271 && n < 4416 ) {
	BLK = 1;
} else
if ( n >= 4416 && n < 4465 ) {
	BLK = 3;
} else
if ( n >= 4465 && n < 4608 ) {
	BLK = 1;
} else
if ( n >= 4608 && n < 4658 ) {
	BLK = 3;
} else
if ( n >= 4658 && n < 4800 ) {
	BLK = 1;
} else
if ( n >= 4800 && n < 4852 ) {
	BLK = 3;
} else
if ( n >= 4852 && n < 4992 ) {
	BLK = 1;
} else
if ( n >= 4992 && n < 5046 ) {
	BLK = 3;
} else
if ( n >= 5046 && n < 5081 ) {
	BLK = 1;
} else
if ( n >= 5081 && n < 5184 ) {
	BLK = 0;
} else
if ( n >= 5184 && n < 5237 ) {
	BLK = 3;
} else
if ( n >= 5237 && n < 5376 ) {
	BLK = 0;
} else
if ( n >= 5376 && n < 5427 ) {
	BLK = 3;
} else
if ( n >= 5427 && n < 5568 ) {
	BLK = 0;
} else
if ( n >= 5568 && n < 5617 ) {
	BLK = 3;
} else
if ( n >= 5617 && n < 5760 ) {
	BLK = 0;
} else
if ( n >= 5760 && n < 5808 ) {
	BLK = 3;
} else
if ( n >= 5808 && n < 5952 ) {
	BLK = 0;
} else
if ( n >= 5952 && n < 5998 ) {
	BLK = 3;
} else
if ( n >= 5998 && n < 6144 ) {
	BLK = 0;
} else
if ( n >= 6144 && n < 6188 ) {
	BLK = 3;
} else
if ( n >= 6188 && n < 6336 ) {
	BLK = 0;
} else
if ( n >= 6336 && n < 6379 ) {
	BLK = 3;
} else
if ( n >= 6379 && n < 6528 ) {
	BLK = 0;
} else
if ( n >= 6528 && n < 6570 ) {
	BLK = 3;
} else
if ( n >= 6570 && n < 6720 ) {
	BLK = 0;
} else
if ( n >= 6720 && n < 6760 ) {
	BLK = 3;
} else
if ( n >= 6760 && n < 6912 ) {
	BLK = 0;
} else
if ( n >= 6912 && n < 6951 ) {
	BLK = 3;
} else
if ( n >= 6951 && n < 7104 ) {
	BLK = 0;
} else
if ( n >= 7104 && n < 7142 ) {
	BLK = 3;
} else
if ( n >= 7142 && n < 7296 ) {
	BLK = 0;
} else
if ( n >= 7296 && n < 7333 ) {
	BLK = 3;
} else
if ( n >= 7333 && n < 7488 ) {
	BLK = 0;
} else
if ( n >= 7488 && n < 7524 ) {
	BLK = 3;
} else
if ( n >= 7524 && n < 7680 ) {
	BLK = 0;
} else
if ( n >= 7680 && n < 7715 ) {
	BLK = 3;
} else
if ( n >= 7715 && n < 7872 ) {
	BLK = 0;
} else
if ( n >= 7872 && n < 7906 ) {
	BLK = 3;
} else
if ( n >= 7906 && n < 8064 ) {
	BLK = 0;
} else
if ( n >= 8064 && n < 8097 ) {
	BLK = 3;
} else
if ( n >= 8097 && n < 18144 ) {
	BLK = 0;
} else
if ( n >= 18144 && n < 18206 ) {
	BLK = 13;
} else
if ( n >= 18206 && n < 18368 ) {
	BLK = 0;
} else
if ( n >= 18368 && n < 18474 ) {
	BLK = 13;
} else
if ( n >= 18474 && n < 18592 ) {
	BLK = 0;
} else
if ( n >= 18592 && n < 18743 ) {
	BLK = 13;
} else
if ( n >= 18743 && n < 18816 ) {
	BLK = 0;
} else
if ( n >= 18816 && n < 19008 ) {
	BLK = 13;
} else
if ( n >= 19008 && n < 19012 ) {
	BLK = 3;
} else
if ( n >= 19012 && n < 19040 ) {
	BLK = 0;
} else
if ( n >= 19040 && n < 20852 ) {
	BLK = 13;
} else
if ( n >= 20852 && n < 100000000 ) {
	BLK = 13;
}

#if 1
	int ii=BLK;
#define DGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
		GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
		( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		DGEMVT_KERNEL_ ( 384 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		DGEMVT_KERNEL_ ( 352 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		DGEMVT_KERNEL_ ( 224 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		DGEMVT_KERNEL_ ( 320 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		DGEMVT_KERNEL_ ( 32 , 5 , 2, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		DGEMVT_KERNEL_ ( 32 , 3 , 2, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		DGEMVT_KERNEL_ ( 96 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		DGEMVT_KERNEL_ ( 32 , 6 , 2, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		DGEMVT_KERNEL_ ( 128 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		DGEMVT_KERNEL_ ( 160 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		DGEMVT_KERNEL_ ( 32 , 4 , 2, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		DGEMVT_KERNEL_ ( 16 , 10 , 2, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		DGEMVT_KERNEL_ ( 16 , 17 , 2, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		DGEMVT_KERNEL_ ( 288 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		DGEMVT_KERNEL_ ( 192 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		DGEMVT_KERNEL_ ( 256 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		DGEMVT_KERNEL_ ( 160 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		DGEMVT_KERNEL_ ( 16 , 6 , 2, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		DGEMVT_KERNEL_ ( 96 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		DGEMVT_KERNEL_ ( 16 , 16 , 2, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

